#include "dxEffectIncludes.h"


typedef struct
{
    float red;
    float green;
    float blue;
} fxVars;

cbuffer variableBuffer : register(b2)
{
    fxVars vars;
}

fxVertexOut vertexShader(fxShaderVerts input)
{
    fxVertexOut output;
    output.position =float4(input.position,1);
    output.normPos = input.position.xy * vec2(.5,.5f) + vec2(.5,.5);
    output.tex1 = input.tex1;
    output.texMask = input.texMask;
    output.texSize = u.texSize;
    return output;
}


float4 pixelShader(fxVertexOut input) : SV_TARGET
{
    vec4 texColor = getColor(inputTex, fsTexture);
    divideAlpha(texColor);

    float4 outColor;
    outColor.rgb=vec3(1.0,1.0,1.0)-texColor.rgb;

    float blendValue=u.blendValue;
    #ifdef USE_MASK
    blendValue*=getColor(inputTexMask,input.texMask).a;
    #endif
    outColor.rgb=mix(texColor.rgb,outColor.rgb,blendValue);
    outColor.a=texColor.a;

    multiplyAlpha(outColor);
    return outColor;
}
