#include "inputShaderHelperDX.h"

v2p vertexShader(vertexInfo input)
{
    v2p output;
    output.position = float4(input.position,1.0);
    output.texCoordY = input.texCoordY;
    output.texCoordUV = input.texCoordY;
    return output;
}




float4 pixelShader(v2p input) : SV_TARGET
{
    float width,height;
    inputTex0.GetDimensions(width,height);
    float2 normalizedTC=input.texCoordY/float2(width,height);

    float4 outColor=textureFetchNearest(inputTex0, normalizedTC).rrrr;

#ifdef FORCE_ALPHA
    outColor.a=1.0;
#endif
    
#ifdef PREMULT
    outColor.rgb*=outColor.a;
#endif

#ifdef USE_MASK
    outColor.a*=textureFetchNearest(maskTex,normalizedTC).a;
#endif
    
#ifdef USE_END_COLOR
    outColor=mix(uniforms.endColor,outColor,uniforms.endOpacity);
#endif
    return outColor;
}
