#version 330

#include "transitionHelperGL.h"
#include "premultiply.h"

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform sampler2DRect maskTex;
uniform float transitionProgress=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform vec4 burnColor;

in vec2 fsTexture;
in vec2 fsTexture2;
in vec2 fsMaskTexture;
in float fsMix;

out vec4 outColor;

void main()
{
    vec4 texColor = getColor(inputTex, fsTexture);
    vec4 burnColor = burnColor;

#ifndef PRE_MULT
    multiplyAlpha(texColor);
    multiplyAlpha(burnColor);
#endif

    vec4 colorA = mix(vec4(0,0,0,0), texColor, fsMix);
    vec4 colorB = mix(texColor, vec4(0,0,0,0), fsMix);
    outColor = mix(colorB + transitionProgress * burnColor,
                   colorA + (1.0 - transitionProgress) * burnColor,
                   transitionProgress);

#ifdef OPACITY_MASK
    float maxOpacity = texColor.a;
    outColor = min(outColor, vec4(maxOpacity));
#endif

    multiplyOpacity(outColor, baseAlpha);

#ifdef USE_MASK
    multiplyOpacity(outColor, texture(maskTex, fsMaskTexture).a);
#endif

#ifndef PRE_MULT
    divideAlpha(outColor);
#endif
}
