#version 330

#include "transitionHelperGL.h"
#include "premultiply.h"

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform sampler2DRect maskTex;
uniform float transitionProgress=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform vec4 burnColor;

in vec2 fsTexture;
in vec2 fsTexture2;
in vec2 fsMaskTexture;

out vec4 outColor;

void main()
{
    vec4 colorA = getColor(inputTex, fsTexture);
    vec4 colorB = getColor(inputTex1, fsTexture2);
    vec4 burnColor = burnColor;

#ifndef PRE_MULT
    multiplyAlpha(colorA);
    multiplyAlpha(colorB);
    multiplyAlpha(burnColor);
#endif

    outColor = mix(colorB + transitionProgress * burnColor,
                   colorA + (1.0 - transitionProgress) * burnColor,
                   transitionProgress);

#ifdef USE_MASK
    multiplyOpacity(outColor, texture(maskTex, fsMaskTexture).a);
#endif

#ifndef PRE_MULT
    divideAlpha(outColor);
#endif
}
