#include "dxShaderIncludes.h"


typedef struct
{
	float4 burnColor;
	float pad[3];
} fxVars;

cbuffer variableBuffer : register(b2)
{
	fxVars vars;
}

vertexOut vertexShader(txShaderVerts input)
{
	vertexOut output;
	output.position = mul(u.worldViewProj,float4(input.position,1));
	output.tex1 = input.tex1;
	output.tex2 = input.tex2;
	output.texMask = input.texMask;
	return output;
}

float4 pixelShader(vertexOut input) : SV_TARGET
{
	float4 colorA = float4(inputTex0.sample(linearSampler,input.tex1));
	float4 colorB = float4(inputTex1.sample(linearSampler,input.tex2));

	float4 outColor=mix(colorB+u.transitionProgress*vars.burnColor,colorA+(1.0-u.transitionProgress)*vars.burnColor,u.transitionProgress)*u.baseAlpha;

#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,input.texMask).a);
#endif

	return outColor;
}
