#include "metalShaderTypes.h"

vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]])
{
    vertexOut out;

    out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}

fragment float4 fragmentFunc(vertexOut input [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& uniforms[[ buffer(2) ]])
{
	float4 texColor0 = float4(inputTex0.sample(linearSampler,input.tex1));
	float4 texColor1 = float4(inputTex1.sample(linearSampler,input.tex2));

#ifndef PRE_MULT
    texColor0.rgb *= texColor0.a;
    texColor1.rgb *= texColor1.a;
#endif

	float4 outColor=mix(texColor1,texColor0,uniforms.transitionProgressLinear);

#ifndef PRE_MULT
    outColor.rgb /= outColor.a;
#endif

#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,input.texMask).a);
#endif

	return outColor;
}
