#include "dxShaderIncludes.h"


typedef struct
{
	float4 burnColor;
	float pad[3];
} fxVars;

cbuffer variableBuffer : register(b2)
{
	fxVars vars;
}

vertexOut vertexShader(txShaderVerts input)
{
	vertexOut output;
	output.position = mul(u.worldViewProj,float4(input.position,1));
	output.tex1 = input.tex1;
	output.tex2 = input.tex2;
	output.texMask = input.texMask;
	output.normPos=input.position.xy*vec2(.5,.5f)+vec2(.5,.5);
	return output;
}

float4 pixelShader(vertexOut input) : SV_TARGET
{
	vec4 colorA = getColor(inputTex0, input.tex1);
	vec4 colorB = getColor(inputTex1, input.tex2);
	float4 burnColor=float4(0,0,0,1);
	float4 outColor;

	if(u.transitionProgressLinear<=.5)
	{
		outColor=mix(colorB,burnColor,u.transitionProgressLinear*2.);
	}
	else
	{
		outColor=mix(burnColor,colorA,(u.transitionProgressLinear-.5f)*2.);
	}

	#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,input.texMask).a);
	#endif

	return outColor;
}
