#version 330

#include "transitionHelperGL.h"
#include "premultiply.h"

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform sampler2DRect maskTex;

uniform float transitionProgressLinear=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform vec4 burnColor=vec4(1,1,1,1);

in vec2 fsTexture;
in vec2 fsTexture2;
in vec2 fsMaskTexture;
in float fsMix;
in float fsABSelect;
out vec4 outColor;

void main()
{
    vec4 texColor = getColor(inputTex, fsTexture);
    outColor = transitionProgressLinear < 0.5
        ? mix(texColor, vec4(0,0,0,0), fsABSelect)
        : mix(vec4(0,0,0,0), texColor, fsABSelect);

#ifndef PRE_MULT
    multiplyAlpha(outColor);
#endif

    outColor = transitionProgressLinear < 0.5
        ? mix(outColor, burnColor, transitionProgressLinear * 2.0)
        : mix(burnColor, outColor, (transitionProgressLinear - 0.5) * 2.0);

#ifdef OPACITY_MASK
    float maxOpacity = texColor.a;
    outColor = min(outColor, vec4(maxOpacity));
#endif

    multiplyOpacity(outColor, baseAlpha);

#ifdef USE_MASK
    multiplyOpacity(outColor, texture(maskTex, fsMaskTexture).a);
#endif

#ifndef PRE_MULT
    divideAlpha(outColor);
#endif
}
