#include "dxShaderIncludes.h"


typedef struct
{
	float4 burnColor;
	float pad[3];
} fxVars;

cbuffer variableBuffer : register(b2)
{
	fxVars vars;
}

vertexOut vertexShader(txShaderVerts input)
{
	vertexOut output;
	output.position = mul(u.worldViewProj,float4(input.position,1));
	output.tex1 = input.tex1;
	output.tex2 = input.tex2;
	output.texMask = input.texMask;
	output.normPos=input.position.xy*vec2(.5,.5f)+vec2(.5,.5);
	return output;
}

float4 pixelShader(vertexOut input) : SV_TARGET
{
	float dist=length(input.tex1-vec2(.5,.5));

	float inAlpha=u.transitionProgress-dist;
	inAlpha*=20.;
	inAlpha=min(inAlpha,1.0);
	inAlpha=max(inAlpha,0.0);

	float outAlpha=dist-u.transitionProgress;
	outAlpha+=.05;
	outAlpha*=20.;
	outAlpha=min(outAlpha,1.0);
	outAlpha=max(outAlpha,0.0);

	vec4 colorA=getColor(inputTex0,input.tex1)*inAlpha;
	vec4 colorB=getColor(inputTex1,input.tex2)*outAlpha;
	float4 outColor=colorA+colorB;
	outColor*=u.baseAlpha;

	#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,input.texMask).a);
	#endif


	return outColor;
}
