
#include "metalShaderTypes.h"

vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]])
{
    vertexOut out;

    out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}


fragment float4 fragmentFunc(vertexOut input [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]]
                             ,constant subFXVars& subVars[[buffer(3)]])
{
	float dist=length(input.tex1-vec2(.5,.5));
	
	float inAlpha=u.transitionProgress-dist;
	inAlpha*=20.;
	inAlpha=min(inAlpha,1.0);
	inAlpha=max(inAlpha,0.0);
	
	float outAlpha=dist-u.transitionProgress;
	outAlpha+=.05;
	outAlpha*=20.;
	outAlpha=min(outAlpha,1.0);
	outAlpha=max(outAlpha,0.0);
	
	vec4 colorA=getColor(inputTex0,input.tex1)*inAlpha;
	vec4 colorB=getColor(inputTex1,input.tex2)*outAlpha;
	float4 outColor=colorA+colorB;
	outColor*=u.baseAlpha;
	
#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,input.texMask).a);
#endif

	return outColor;
}
