// Copyright (c) Renewed Vision, LLC. All rights reserved.
#ifndef Premultiply_h
#define Premultiply_h

#define multiplyOpacity(color, alpha) color = min(color * alpha, vec4(alpha, alpha, alpha, alpha));

#define divideAlpha(color) color.rgb = ((0.0 < color.a && color.a < 1.0) ? color.rgb / color.a : color.rgb);
#define multiplyAlpha(color) color.rgb = min(color.rgb * color.a, vec3(color.a, color.a, color.a));

#if defined(MULTIPLY_ALPHA) && !defined(DIVIDE_ALPHA)
#define processAlpha(color) multiplyAlpha(color)
#elif defined(DIVIDE_ALPHA) && !defined(MULTIPLY_ALPHA)
#define processAlpha(color) divideAlpha(color)
#else
#define processAlpha(color)
#endif

#endif  // Premultiply_h
