#include "dxShaderIncludes.h"


vertexOut vertexShader(txShaderVerts input)
{
	vertexOut output;
	output.position = mul(u.worldViewProj,float4(input.position,1));
	output.tex1 = input.tex1;
	output.tex2 = input.tex2;
	output.texMask = input.texMask;
	output.normPos=input.position.xy*vec2(.5,.5f)+vec2(.5,.5);
	return output;
}


float4 pixelShader(vertexOut input) : SV_TARGET
{
	float x1 = u.transitionProgressLinear;
	vec2 p1 = input.tex1;

	x1=smoothstep(.20,.80,(x1*2.0+p1.x-1.0));

	vec2 tc1=(p1-.5)*(1.-x1)+.5;

	tc1=(p1-.5)*x1+.5;

	vec2 texA=mix(tc1,p1,u.transitionProgressLinear);
	vec2 texB=mix(p1,tc1,u.transitionProgressLinear);
	vec2 useTex=mix(texB,texA,u.mix);

	vec4 texColor=getColor(inputTex0,useTex);

	float fsMix=u.transitionProgress;
	if(u.transitionState==2)
	fsMix=1.0-u.transitionProgress;
	vec4 outColor=texColor*fsMix*u.baseAlpha;

	#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,input.texMask).a);
	#endif

	return outColor;
}
